#include <avr/io.h>
#include <util/delay.h>
#include "bargraf.h"

typedef struct{
	unsigned char data[10][2];
	unsigned char blinknum;
	unsigned char blink:1;
} bargraf_data;

bargraf_data bargraf;

void bargraf_init(){

	DDRB |= BAR_PB_MASK;	// 1100 0000
	DDRC |= BAR_PC_MASK;	// 0011 1100
	DDRD |= BAR_PD_MASK;	// 0001 1100

	BAR_IN1_OFF
	BAR_IN2_OFF
	BAR_IN3_OFF
	BAR_IN4_OFF
	BAR_IN5_OFF
	
	BAR_OUT1_ON
	BAR_OUT2_ON
	BAR_OUT3_ON
	BAR_OUT4_ON	
	
	bargraf.blinknum=0;
	bargraf.blink=0;
	
	for(int i=0;i<10;i++)
	  for(int j=0;j<2;j++)
	    bargraf.data[i][j]=BAR_OFF;

}

void bargraf_draw(){

	int i;
	BAR_IN1_OFF
	BAR_IN2_OFF
	BAR_IN3_OFF
	BAR_IN4_OFF
	BAR_IN5_OFF
	
	bargraf.blinknum++;
	
	if(bargraf.blinknum>=50){
		bargraf.blink = (bargraf.blink==0?1:0);
		bargraf.blinknum=0;
	}
	
	for( i=0; i<10; i+=2 ){
		
			 if(i>=8) BAR_IN5_ON
		else if(i>=6) BAR_IN4_ON
		else if(i>=4) BAR_IN3_ON
		else if(i>=2) BAR_IN2_ON
		else if(i>=0) BAR_IN1_ON
		
		if(bargraf.data[i][BAR_GRN]==1 || (bargraf.data[i][BAR_GRN]==2 && bargraf.blink==1)){
			BAR_OUT1_OFF
			BAR_WAIT
			BAR_OUT1_ON
		}
		else BAR_WAIT
		
		if(bargraf.data[i][BAR_RED]==1 || (bargraf.data[i][BAR_RED]==2 && bargraf.blink==0)){
			BAR_OUT2_OFF
			BAR_WAIT
			BAR_OUT2_ON
		}
		else BAR_WAIT
		
		if(bargraf.data[i+1][BAR_GRN]==1 || (bargraf.data[i+1][BAR_GRN]==2 && bargraf.blink==1)){
			BAR_OUT3_OFF
			BAR_WAIT
			BAR_OUT3_ON
		}
		else BAR_WAIT
		
		if(bargraf.data[i+1][BAR_RED]==1 || (bargraf.data[i+1][BAR_RED]==2 && bargraf.blink==0)){
			BAR_OUT4_OFF
			BAR_WAIT
			BAR_OUT4_ON
		}
		else BAR_WAIT
		
			 if(i>=8) BAR_IN5_OFF
		else if(i>=6) BAR_IN4_OFF
		else if(i>=4) BAR_IN3_OFF
		else if(i>=2) BAR_IN2_OFF
		else if(i>=0) BAR_IN1_OFF
		
	}

}

void bargraf_line(int kolor, int ile,int status){
	int i;
	if(ile>10) ile=10;
    for( i=0; i<10-ile; i++)	bargraf.data[i][kolor] = BAR_OFF;
	for( i=10-ile; i<10; i++)	bargraf.data[i][kolor] = status;
}

void bargraf_clear(){
	int i;
	for( i=0;i<10;i++ ){
		bargraf.data[i][BAR_GRN]=0;
		bargraf.data[i][BAR_RED]=0;
	}
}